小工具知识网

当前位置: 首页 > 行业知识 > 代码随想录算法训练营第35天 | 435. 无重叠区间 ,763.划分字母区间 , 56. 合并区间

行业知识

代码随想录算法训练营第35天 | 435. 无重叠区间 ,763.划分字母区间 , 56. 合并区间

2026-10-29 10:49:43 来源:互联网转载

贪心算法章节理论基础:

https://programmercarl.com/%E8%B4%AA%E5%BF%83%E7%AE%97%E6%B3%95%E7%90%86%E8%AE%BA%E5%9F%BA%E7%A1%80.html

435. 无重叠区间

题目链接:https://leetcode.cn/problems/non-overlapping-intervals/

思路:

相信很多同学看到这道题目都冥冥之中感觉要排序,但是究竟是按照右边界排序,还是按照左边界排序呢?

其实都可以。主要就是为了让区间尽可能的重叠。

我来按照右边界排序,从左向右记录非交叉区间的个数。最后用区间总数减去非交叉区间的个数就是需要移除的区间个数了。

此时问题就是要求非交叉区间的最大个数。

这里记录非交叉区间的个数还是有技巧的,如图:

区间,1,2,3,4,5,6都按照右边界排好序。

当确定区间 1 和 区间2 重叠后,取 区间1 和 区间2 右边界的最小值,来确定是否与 区间3 也重贴。取 区间1 和 区间2 右边界的最小值,因为这个最小值之前的部分一定是 区间1 和区间2 的重合部分,如果这个最小值也触达到区间3,那么说明 区间 1,2,3都是重合的。

找大于区间1结束位置的区间,是从区间4开始。不从区间5开始,是因为已经是按照右边界排序的了。

区间4结束之后,再找到区间6,所以一共记录非交叉区间的个数是三个。

总共区间个数为6,减去非交叉区间的个数3。移除区间的最小数量就是3。

class Solution {    public int eraseOverlapIntervals(int[][] intervals) {        // 按右边界排序        Arrays.sort(intervals,(a,b) -> {            return Integer.compare(a[1],b[1]);        });        // 交叉的数量        int cnt = 0;        int pre = intervals[0][1];        for(int i=1;i            if(pre  intervals[i][0]){                cnt++;  // 因为是按右边界排序的,所以红线还是最小值            }else                pre = intervals[i][1];        }        return cnt;    }}

763.划分字母区间

题目链接:https://leetcode.cn/problems/partition-labels/

思路:

一想到分割字符串就想到了回溯,但本题其实不用回溯去暴力搜索。

题目要求同一字母最多出现在一个片段中,那么如何把同一个字母的都圈在同一个区间里呢?

如果没有接触过这种题目的话,还挺有难度的。

在遍历的过程中相当于是要找每一个字母的边界,如果找到之前遍历过的所有字母的最远边界,说明这个边界就是分割点了。此时前面出现过所有字母,最远也就到这个边界了。

可以分为如下两步:

  • 统计每一个字符最后出现的位置
  • 从头遍历字符,并更新字符的最远出现下标,如果找到字符最远出现位置下标和当前下标相等了,则找到了分割点

    如图:

    class Solution {    public List partitionLabels(String s) {        int[] arr = new int[26];        int len = s.length();        // 统计每一个字符最后出现的位置        for(int i = 0;i            char c = s.charAt(i);            arr[c-'a'] = i+1;        }        int left = 0;        int right = 0;        List            // 找到字符最远的右边界            right = Math.max(right,arr[s.charAt(i)-'a']);               if(right == i+1){                list.add(right - left);                left = right;            }        }        return list;    }}    public int[][] merge(int[][] intervals) {        // [[2,3],[4,5],[6,7],[1,10]] 要按左排序        Arrays.sort(intervals,(a,b) - {            return Integer.compare(a[0],b[0]);        });        List            if(intervals[i][0]                 right = Math.max(intervals[i][1],right);            }else{                res.add(new int[]{left,right});                left = intervals[i][0];                right = intervals[i][1];            }        }        res.add(new int[]{left,right});        return res.toArray(new int[res.size()][]);    }}

上一篇:小红书PC版使用详解与体验分享,打造优质生活指南!

下一篇:广东文明网下载攻略,轻松掌握下载步骤,一键获取资源!